/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SAMPLE_MODELS_H
#define __SAMPLE_MODELS_H

#include "magnum.graphics.h"
#include "magnum.graphics3d.h"
#include "magnum.io.h"


namespace magnum { namespace sample {
using magnum::graphics3d::Shader;
using magnum::graphics3d::Texture;
using magnum::graphics3d::Model;
using magnum::graphics3d::StaticModel;
using magnum::graphics3d::BoneModel;
using magnum::graphics3d::FrameModel;
using magnum::graphics3d::MeshList;
using magnum::io::FileFactory;

Model* createTetra();
Model* createTrilist();
Model* create3ds();
Model* createIfs();
Model* createPly();
Model* createMd2();
Model* createLwo();

StaticModel* create3ds(FileFactory* ,const char* );
StaticModel* createIfs(FileFactory* ,const char* );
StaticModel* createPly(FileFactory* ,const char* );
FrameModel* createMd2(FileFactory* ,const char* );
FrameModel* createMd3(FileFactory* ,const char* );
BoneModel* createMds(FileFactory* ,const char* );
StaticModel* createLwo(FileFactory* ,const char* );
StaticModel* createObj(FileFactory* ,const char* );

void applySkins(const MeshList& ,FileFactory* ,const char* );

void setShader(const MeshList& ,Shader* );
void setTexture(const MeshList& ,Texture* ,unsigned int );
void clearTexture(const MeshList& ,unsigned int );

void setBumpMaterial(const MeshList& meshes);
void setEnvMaterial(const MeshList& meshes);
void setEnvBumpMaterial(const MeshList& meshes);
void setTexEnvBumpMaterial(const MeshList& meshes);
void setTextureMaterial(const MeshList& meshes);

}; };

#endif
